/***************************************************************************
 * This confidential and proprietary software may be used only as
 * authorised by a licensing agreement from ARM Limited
 *  (C) COPYRIGHT 2001 ARM Limited
 *      ALL RIGHTS RESERVED
 * The entire notice above must be reproduced on all authorised
 * copies and copies may only be made to the extent permitted
 * by a licensing agreement from ARM Limited.
 ***************************************************************************/
/*****************************************************************************
 *								      
 * Defines, Structures, Routines used & defined in the logic demo program
 *
 *	$Id: logic.h,v 1.1 1999/11/22 10:41:07 mwelsh Exp $
 *
 *****************************************************************************/

#define SC_ISTAT     0x14000000
#define SC_IENSET    0x14000008

#define LM_OSC1      0xC0000000
#define LM_OSC2      0xC0000004
#define LM_LOCK      0xC0000008
#define LM_LEDS      0xC000000C
#define LM_INT       0xC0000010
#define LM_SW        0xC0000014

#define LM_ISTAT     0xC1000000
#define LM_IENSET    0xC1000008

#define LMSSRAMSTART 0xC2000000
#define LMSSRAMEND   0xC20FFFFF

#define UNLOCK       0x0000A05F
#define LOCK         0x00000000
#define ONEMHZ       0x00067C04
#define TWOMHZ       0x00063C04
#define FIVEMHZ      0x00061C07
#define TENMHZ       0x00060C07
#define TWENTYMHZ    0x00060407

#define LED_DELAY    0x0000FFFF
#define EXP_HDR_0	 0x09

/* ****************************************************************
 * Function declarations 
 * ****************************************************************/
/* defined in rw_support.s */
extern void word_write(int addr, int data);
extern int  word_read(int addr);
extern void hword_write(int addr, int data);
extern int  hword_read(int addr);
extern void byte_write(int addr, int data);
extern int  byte_read(int addr);

/* defined in logic.c */
extern void ConfigureMemory(void);
extern int  TestSsram(int start, int end);
extern int  ClearSsram(int start, int end);
