; ************************************************
; * This confidential and proprietary software may be used only as
; * authorised by a licensing agreement from ARM Limited
; *   (C) COPYRIGHT 2001 ARM Limited
; *       ALL RIGHTS RESERVED
; * The entire notice above must be reproduced on all authorised
; * copies and copies may only be made to the extent permitted
; * by a licensing agreement from ARM Limited.
; ************************************************/
; ***************************************************************
; *
; * Read / Write support functions for logic module demo
; * program.
; *
; * $Id: rw_support.s,v 1.1 1999/11/22 10:41:19 mwelsh Exp $
; *
; ***************************************************************

    EXPORT word_write
    EXPORT word_read
    EXPORT hword_write
    EXPORT hword_read
    EXPORT byte_write
    EXPORT byte_read

    AREA rw_support, CODE, READONLY ;READONLY is default for CODE

;-----------------------------------------------------------------
; word_write(int addr, int data)
; writes a word to an address
;-----------------------------------------------------------------
;r0 contains addr
;r1 contains data
word_write
    STMFD SP!,{lr}  ; save return address to stack
    STR r1,[r0,#0]  ; store data
    LDMFD SP!,{pc}  ; return

;-----------------------------------------------------------------
; word_read(int addr)
; reads a word from an address
;-----------------------------------------------------------------
 ;r0 contains addr

word_read
    STMFD SP!,{r1,lr}  ; save return address and r1 to stack 
    LDR r1,[r0,#0]     ; load temp with data
    MOV r0, r1         ; copy temp to r0 for return value
    LDMFD SP!,{r1,pc}  ; return
 
 ;-----------------------------------------------------------------
; hword_write(int addr, int data)
; writes a half word to an address
;-----------------------------------------------------------------
;r0 contains addr
;r1 contains data
hword_write
    STMFD SP!,{lr}  ; save return address to stack
    STRH r1,[r0,#0] ; store data
    LDMFD SP!,{pc}  ; return

;-----------------------------------------------------------------
; hword_read(int addr)
; reads a half word from an address
;-----------------------------------------------------------------
;r0 contains addr

hword_read
    STMFD SP!,{r1,lr}  ; save return address and r1 to stack
    LDRH r1,[r0,#0]    ; load temp with data
    MOV r0, r1         ; copy temp to r0 for return value
    LDMFD SP!,{r1,pc}  ; return
 
;-----------------------------------------------------------------
; byte_write(int addr, int data)
; writes a byte to an address
;-----------------------------------------------------------------
;r0 contains addr
;r1 contains data

byte_write
    STMFD SP!,{lr}  ; save return address to stack
    STRB r1,[r0,#0] ; store data
    LDMFD SP!,{pc}  ; return
 
;-----------------------------------------------------------------
; byte_read(int addr)
; reads a byte from an address
;-----------------------------------------------------------------
;r0 contains addr

byte_read
    STMFD SP!,{r1,lr}  ; save return address and r1 to stack 
    LDRB r1,[r0,#0]    ; load temp with data
    MOV r0, r1         ; copy temp to r0 for return value    
    LDMFD SP!,{r1,pc}  ; return 
 
    END